from solver4 import *
import math

def close_enough(a,b):
	epsilon = 0.01
	return abs(a-b)<epsilon

s = Simulation()

# Correlation matrix will be same every time it is calculated, so no need to recalculate often
s.max_outer_timestep = 1.0

# Inner timestep must be small to keep the approximation accurate
s.max_inner_timestep = 0.0001

x = Variable()
x.derivative = a = Variable()

C1 = Constraint(Expr.sum(Expr.variable(x), Expr.product(Expr.constant(-1), Expr.variable(a))))

s.add_variable(x)
s.add_variable(a)
s.add_constraint(C1)

start = {x:1, a:1}
times = [s.calculate_change(start, i) for i in range(4)]

assert close_enough(times[0][x], math.e**0)
assert close_enough(times[1][x], math.e**1)
assert close_enough(times[2][x], math.e**2)
assert close_enough(times[3][x], math.e**3)