from solver4 import *
import math

def close_enough(a,b):
	epsilon = 0.001
	return abs(a-b)<epsilon

s = Simulation()

# Correlation matrix will be same every time it is calculated, so no need to recalculate often
s.max_outer_timestep = 1.0

# Inner timestep must be small to keep the approximation accurate
s.max_inner_timestep = 0.001

sin = Variable()
cos = Variable()
sin.derivative = Variable()
cos.derivative = Variable()

# dsin = cos
# dcos = -sin
# ddsin = -sin
# ddcos = -cos

C1 = Constraint(Expr.sum(Expr.variable(sin.derivative), Expr.product(Expr.constant(-1), Expr.variable(cos)))) # sin.derivative = cos
C2 = Constraint(Expr.sum(Expr.variable(cos.derivative), Expr.variable(sin))) # cos.derivative = -sin

s.add_variable(sin)
s.add_variable(cos)
s.add_variable(sin.derivative)
s.add_variable(cos.derivative)
s.add_constraint(C1)
s.add_constraint(C2)

vars = {sin:0, cos:1, sin.derivative:1, cos.derivative:0}
vars = s.calculate_change(vars, math.pi/8)
assert close_enough(vars[sin], math.sin(math.pi*1/8))
vars = s.calculate_change(vars, math.pi/8)
assert close_enough(vars[sin], math.sin(math.pi*2/8))
