from solver4 import *

# This test solves an underspecified system of equations. The only constraint is that a = -b; a and
# b are allowed to be anything as long as a+b = 0, and c can be anything at all. The solver will
# assign values to all three.

s = Simulation()

a = Variable()
b = Variable()
c = Variable()

C1 = Constraint(Expr.sum(Expr.variable(a), Expr.variable(b)))
C1.tolerance = 0.0

s.add_variable(a)
s.add_variable(b)
s.add_variable(c)
s.add_constraint(C1)

answer = s.calculate_completion({})

assert answer[a] + answer[b] == 0
